/** 
 * Copyright (C) 2008 Alan Ross, ( http://lab.adjazent.com )
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
*/
package ar.particlepainter.particles 
{
	import ar.particlepainter.particles.Particle;
	
	import flash.display.BitmapData;
	import flash.geom.Point;	

	/**
	 * @author Alan Ross
	 */
	public class ShapeParticle extends Particle
	{
		public var next: ShapeParticle;
		
		public var distToOrigin: int;
		
		public var size: int;
		
		public var shape: BitmapData;
		
		private var _p: Point = new Point( );

		/**
		 * Create a new <code>ShapeParticle</code> object.
		 */
		public function ShapeParticle()
		{
			lifespan = 1 + ( 20 * Math.random() );
			size = 1 + ( 2 * Math.random() );
		}

		/**
		 * @inheritDoc
		 */
		override public function paint( b: BitmapData ): void
		{
			_p.x = x;
			_p.y = y;
			b.copyPixels( shape, shape.rect, _p );
		}
	}
}
